variables:
  GOLANG_VERSION: 1.19.9
  MYSQL_DATABASE: default
  MYSQL_ROOT_PASSWORD: password

run_unittest_golang:
  stage: test
  image: 'golang:${GOLANG_VERSION}'
  services:
    - trufflesuite/ganache:latest
    - redis:latest
    - mysql:latest
  before_script:
    - go get github.com/boumenot/gocover-cobertura
  script:
    - go test -race -coverprofile=coverage.txt -covermode=atomic -v ./...
    - go run github.com/boumenot/gocover-cobertura < coverage.txt > coverage.xml
    - |
      COVERAGE_PERCEN=$(go tool cover -func coverage.txt | awk '{ print $3 }')
      echo "COVERAGE_PERCENT=${TARGET_URL}" >> unittest.env
  artifacts:
    reports:
      dotenv: unittest.env
  artifacts:
    reports:
      coverage_report:
        coverage_format: cobertura
        path: coverage.xml
  rules:
    - if: '$AUTO_DEVOPS_PLATFORM_TARGET == "EC2"'
      when: never
    - if: '$LANGUAGE != "go"'
      when: never
    - if: '$CI_COMMIT_TAG || $CI_COMMIT_BRANCH'

